#include "EventManager.h"


EventManager::EventManager(void)
{
	int	i;

	for(i = 0; i < 255; i++) {
		preKeySt[i] = false;
		nowKeySt[i] = false;
	}
	for(i = 0; i < 32; i++) {
		preSPKeySt[i] = false;
		nowSPKeySt[i] = false;
	}
	for(i = 0; i < 3; i++) {
		preMouseSt[i] = false;
		nowMouseSt[i] = false;
	}

	nowMousePos.init();
	preMousePos.init();

	return;
}

EventManager::~EventManager(void)
{
}

void EventManager::update(fk_Window *argWin)
{
	int	i, x, y;

	for(i = 0; i < 255; i++) {
		preKeySt[i] = nowKeySt[i];
		nowKeySt[i] = argWin->getKeyStatus((char)i, false);
	}
	for(i = 0; i < 32; i++) {
		preSPKeySt[i] = nowSPKeySt[i];
		nowSPKeySt[i] = argWin->getSpecialKeyStatus((fk_SpecialKey)i, false);
	}
	for(i = 0; i < 3; i++) {
		preMouseSt[i] = nowMouseSt[i];
		nowMouseSt[i] = argWin->getMouseStatus((fk_MouseButton)i, false);
	}

	preMousePos = nowMousePos;
	argWin->getMousePosition(&x, &y, false);
	nowMousePos.set((double)x, (double)y, 0.0);

	return;
}

fkut_SwitchStatus EventManager::GetSwitchStatus(bool now, bool pre)
{
	switch((int)now*2 + (int)pre) {
	  case 0:
		return FKUT_SW_RELEASE;
	  case 1:
		return FKUT_SW_UP;
	  case 2:
		return FKUT_SW_DOWN;
	  case 3:
		return FKUT_SW_PRESS;
	  default:
		return FKUT_SW_RELEASE;
	}
}

fkut_SwitchStatus EventManager::getKeyStatus(char argKey)
{
	return GetSwitchStatus(nowKeySt[(int)argKey], preKeySt[(int)argKey]);
}

fkut_SwitchStatus EventManager::getSpecialKeyStatus(fk_SpecialKey argKey)
{
	return GetSwitchStatus(nowSPKeySt[(int)argKey], preSPKeySt[(int)argKey]);
}

fkut_SwitchStatus EventManager::getMouseStatus(fk_MouseButton argButton)
{
	return GetSwitchStatus(nowMouseSt[(int)argButton], preMouseSt[(int)argButton]);
}

fk_Vector EventManager::getMousePosition(void)
{
	return nowMousePos;
}
