#pragma once

#include <FK/FK.h>

enum fkut_SwitchStatus {
	FKUT_SW_RELEASE,
	FKUT_SW_UP,
	FKUT_SW_DOWN,
	FKUT_SW_PRESS
};

class EventManager {
  private:
	bool		nowKeySt[256], nowSPKeySt[32], nowMouseSt[3];
	bool		preKeySt[256], preSPKeySt[32], preMouseSt[3];
	fk_Vector	nowMousePos, preMousePos;

	fkut_SwitchStatus	GetSwitchStatus(bool now, bool pre);

  public:
	EventManager(void);
	~EventManager(void);

	void update(fk_Window *argWin);

	fkut_SwitchStatus	getKeyStatus(char keyChar);
	fkut_SwitchStatus	getSpecialKeyStatus(fk_SpecialKey keyCode);
	fkut_SwitchStatus	getMouseStatus(fk_MouseButton buttonCode);
	fk_Vector			getMousePosition(void);
};
