#include "TestApp.h"

TestApp::TestApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin)
{
}

TestApp::~TestApp(void)
{
}

void TestApp::init(void)
{
	lightModel.setShape(&light);
	lightModel.glFocus(1.0, -1.0, -1.0);
	lightModel.setMaterial(White);

	block.setSize(50.0, 50.0, 50.0);
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);

	camera.glMoveTo(0.0, 0.0, 500.0);
	camera.glFocus(0.0, 0.0, 0.0);

	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&blockModel);

	drawWin->setScene(&scene);

	return;
}

bool TestApp::procLoop(void)
{
	blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.1);

	return true;
}
